/////////////////////////////////////////////////////////////////////////////
//
//  GEM Window
//
//  A GEMwindow is a standard GEM window, which acts just like that as
//  a base class.  Its contents is undefined, and redraw requests have
//  no effect - derived classes should implement this.  It does, however,
//  handle the requirement of clipping the redraw area - a standard
//  requirement of GEM windows.
//
//  This file is Copyright 1992 by Warwick W. Allison,
//  and is freely distributable providing no charge is made.
//
/////////////////////////////////////////////////////////////////////////////

#ifndef GEMW_h
#define GEMW_h

#include "gemfeedb.h"
#include <gemfast.h>
#include <bool.h>

class GEMwindow
{
public:
	GEMwindow(int Parts, GRECT&);
	GEMwindow(int Parts=0);
	virtual ~GEMwindow();

	void title(const char *);

	void open();
	void close();
	virtual void top(int X, int Y);		// Top attempted by clicking at (x,y)
	virtual void move(int X, int Y);
	virtual ClickResult click(int X, int Y);

	virtual void Redraw(GRECT&) { }

	void RedrawOverlaps(GRECT&); // Calls Redraw

protected:
	int Handle;
	int parts;
	GRECT Pos;
	bool Open;

public:
	int handle() { return Handle; }
};

#endif
